
def loadFasta(filename):

    f = open(filename)
    seqs = {}
    seqname=""
    seq=""

    for row in f:
        if row[0] == '>':
            if seqname:
                seqs[seqname] = seq                
            seqname=row.split()[0][1:]
            seq=""
        else:
            seq+=row.rstrip()
    if seqname:
        seqs[seqname] = seq


    f.close()
    return seqs


def loadSites(filename):

    f = open(filename)

    sites=[]

    for row in f.readlines()[1:]:
        data = row.split()
        data[2]=int(data[2])
        data[3]=int(data[3])
        sites.append(data)

    f.close()
    return sites


def findPatternFreq(sites, fasta, k):
    
    freqs={}

    for target in sites:
        seq=fasta[target[0]]
        subseq=seq[target[2]-1:target[3]]
        if len(subseq) >= k:
            subseqhead=subseq[:k]
            if not freqs.has_key(subseqhead):
                freqs[subseqhead] = 0
            freqs[subseqhead] += 1
                
    return freqs


def printPatternFreq(freqs):
    
    print "\n".join([pat + "\t" + str(freq) for pat,freq in freqs.items()])


def findBindingPatternFreqs(sitefile, fastafile, k):
    
    sites=loadSites(sitefile)
    fasta=loadFasta(fastafile)
   
    freqs=findPatternFreq(sites, fasta, k)
    printPatternFreq(freqs) 

findBindingPatternFreqs('binding_sites','seq.fasta', 5)
